﻿#define _CRT_SECURE_NO_WARNINGS
using namespace std;

#include <iostream>
#include <algorithm>
#include <string>
#include <vector>

typedef long long ll;

#define size(x) (int)x.size()


vector<pair<int, int>> a;

int len(int x) {
	if (x == 0) return 1;
	int ret = 0;
	while (x) {
		ret++;
		x /= 10;
	}
	return ret;
}

int f(pair<int, int> a) {
	if (a.second == 0) return 0;
	if (a.second == 1) return 1;
	return 1 + len(a.second);
}

int f(int a, int b) {
	if (b == 0) return 0;
	if (b == 1) return 1;
	return 1 + len(b);
}

int f(int d) {
	if (d == 0) return 0;
	if (d == 1) return 1;
	return 1 + len(d);
}

int pw10(int n) {
	--n;
	int ret = 1;
	while (n--) ret *= 10;
	return ret;
}

vector<char> cs = { 'A', 'G', 'C', 'T' };

void solve(int sn) {
	int best = 0;
	for (auto v : a) {
		best += f(v);
	}
	int init = best;
	int tp = -1, x = -1, Z = -1;
	int pos = 0;
	auto relax = [&](int len, int tp_, int x_, int z_) {
		if (best * sn <= len * sn) {
			best = len;
			tp = tp_; x = x_; Z = z_;
		}
	};
	for (int i = 1; i + 1 < size(a); i++) {
		// try to add
		// слева
		{
			for (char c : cs) {
				if (a[i - 1].first == c) {
					relax(init - f(a[i - 1]) + f(a[i - 1].second + 1), 1, pos, c);
				}
				else if (a[i].first == c) {
					relax(init - f(a[i]) + f(a[i].second + 1), 1, pos, c);
				}
				else {
					relax(init + 1, 1, pos, c);
				}
			}
		}
		// справа
		{
			for (char c : cs) {
				if (a[i + 1].first == c) {
					relax(init - f(a[i + 1]) + f(a[i + 1].second + 1), 1, pos + a[i].second, c);
				}
				else if (a[i].first != c) {
					relax(init + 1, 1, pos + a[i].second, c);
				}
			}
		}
		// посередине
		{
			if (a[i].second != 1) {
				for (char c : cs) {
					if (a[i].first != c) {
						relax(init - f(a[i]) + f(1) + f(a[i].second - 1) + 1, 1, pos + 1, c);
						relax(init - f(a[i]) + f(2) + f(1) + f(a[i].second - 2), 1, pos + 2, c);
						relax(init - f(a[i]) + f(pw10(len(a[i].second - 1))) + 1 + f(a[i].second - pw10(len(a[i].second - 1))), 1, pos + pw10(len(a[i].second - 1)), c);
					}
				}
			}
		}
		// try to remove
		if (a[i].second != 1) {
			relax(init - f(a[i]) + f(a[i].second - 1), 2, pos + 1, -1);
		}
		else {
			if (a[i - 1].first == a[i + 1].first) {
				relax(init - 1 - f(a[i - 1]) - f(a[i + 1]) + f(a[i - 1].second + a[i + 1].second), 2, pos + 1, -1);
			}
			else {
				relax(init - 1, 2, pos + 1, -1);
			}
		}
		// try to change
		if (a[i].second == 1) {
			for (char c : cs) {
				if (c != a[i].first) {
					if (a[i - 1].first == c) {
						if (a[i + 1].first == c) {
							relax(init - 1 - f(a[i - 1]) - f(a[i + 1]) + f(a[i - 1].second + 1 + a[i + 1].second), 3, pos + 1, c);
						}
						else {
							relax(init - 1 - f(a[i - 1]) + f(a[i - 1].second + 1), 3, pos + 1, c);
						}
					}
					else if (a[i + 1].first == c) {
						relax(init - 1 - f(a[i + 1]) + f(a[i + 1].second + 1), 3, pos + 1, c);
					}
					else {
						relax(init, 3, pos + 1, c);
					}
				}
			}
		}
		else {
			// слева
			{
				for (char c : cs) {
					if (c != a[i].first) {
						if (a[i - 1].first == c) {
							relax(init - f(a[i]) - f(a[i - 1]) + f(a[i].second - 1) + f(a[i - 1].second + 1), 3, pos + 1, c);
						}
						else {
							relax(init - f(a[i]) + f(a[i].second - 1) + 1, 3, pos + 1, c);
						}
					}
				}
			}
			// справа
			{
				for (char c : cs) {
					if (c != a[i].first) {
						if (a[i + 1].first == c) {
							relax(init - f(a[i]) - f(a[i + 1]) + f(a[i].second - 1) + f(a[i + 1].second + 1), 3, pos + a[i].second, c);
						}
						else {
							relax(init - f(a[i]) + f(a[i].second - 1) + 1, 3, pos + a[i].second, c);
						}
					}
				}
			}
			// посередине
			{
				if (a[i].second > 2) {
					for (char c : cs) {
						if (c != a[i].first) {
							relax(init - f(a[i]) + f(1) * 2 + f(a[i].second - 2), 3, pos + 2, c);
						}
					}
				}
			}
		}
	
		pos += a[i].second;
	}
	cout << tp << ' ' << x << ' ';
	if (tp != 2) cout << char(Z);
	cout << '\n';
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	string s;
	cin >> s;
	a.emplace_back(1, 0);
	for (int i = 0; i < size(s); i++) {
		int sz = 0;
		for (; i < size(s); i++) {
			if ('0' <= s[i] && s[i] <= '9') {
				sz = sz * 10 + (s[i] - '0');
			}
			else {
				break;
			}
		}
		char c = s[i];
		if (sz == 0) sz = 1;
		a.emplace_back(c, sz);
	}
	a.emplace_back(2, 0);
	solve(-1);
	solve(1);
}
