﻿#define _CRT_SECURE_NO_WARNINGS
using namespace std;

#include <iostream>
#include <vector>
#include <map>
#include <assert.h>
#include <random>
#include <numeric>
#include <unordered_map>
#include <time.h>
#include <algorithm>

#pragma GCC optimize("Ofast", "unroll-loops")

typedef long long ll;

#define size(x) (int)x.size()
#define all(x) (x).begin(), (x).end()

vector<pair<int, int>> a;
const int N = 3e5 + 2;
vector<int> g[N];
int used[N];

void checkComp(int x) {
	used[x] = 1;
	for (int to : g[x]) {
		if (!used[to]) checkComp(to);
	}
}

vector<int> ord;

map<pair<int, int>, int> cntE;

const ll INF = 1e9 + 5;


bool FL = 0;

pair<int, int> Hash(int a, int b) {
	if (a < b) swap(a, b);
	return { a, b };
}

ll myHash(int a, int b) {
	return a * INF + b;
}

void dfs(int x) {
	while (!g[x].empty()) {
		int to = g[x].back();
		g[x].pop_back();
		if (cntE[Hash(x, to)] == 0) continue;
		cntE[Hash(x, to)]--;
		dfs(to);
		ord.push_back(x);
	}

}

void solve(int step) {
	int n = size(a);
	ord.clear();
	cntE.clear();
	vector<int> xs;
	for (int i = 0; i < n; i++) {
		xs.push_back(a[i].first);
	}
	sort(all(xs));
	xs.resize(unique(all(xs)) - xs.begin());	
	for (int i = 0; i < size(xs); i++) {
		g[i].clear();
	}
	unordered_map<ll, vector<int>> vs;
	int cntEd = 0;
	// проверить что все a[i].second <= step(кроме последнего)
	for (int i = 0; i < n; i++) {
		int o = a[i].first;
		a[i].second = step - a[i].second;
		a[i].first = lower_bound(all(xs), a[i].first) - xs.begin();
		if (a[i].second >= 0) {
			int t = lower_bound(all(xs), a[i].second) - xs.begin();
			if (t < size(xs) && xs[t] == a[i].second) {
				vs[myHash(a[i].first, t)].push_back(i);
				//cout << a[i].first << ' ' << t << endl;
				cntEd++;
				g[a[i].first].push_back(t);
				g[t].push_back(a[i].first);
			}
		}
	}
	if (cntEd < n - 1) return;
	int cnt = 0;
	for (int i = 0; i < size(xs); i++) {
		if (size(g[i]) & 1) cnt++;
	}
	if (cnt != 0 && cnt != 2) return;
	fill(used, used + size(xs), 0);
	checkComp(0);
	for (int i = 0; i < size(xs); i++) {
		if (!used[i]) {
			return;
		}
	}
	if (cnt == 0 || cnt == 2) {
		pair<int, int> d = { -1, -1 };
		if (cnt == 2) {
			int a = -1;
			for (int i = 0; i < size(xs); i++) {
				if (size(g[i]) & 1) {
					if (a == -1) {
						a = i;
					}
					else {
						g[a].push_back(i);
						g[i].push_back(a);
						d = { a, i };
					}
				}
			}
		}
		for (int i = 0; i < size(xs); i++) {
			for (int to : g[i]) {
				if (i <= to) cntE[Hash(i, to)]++;
			}
			cntE[Hash(i, i)] /= 2;
		}
	//	cout << cntE[Hash(1, 0)] << endl;
		fill(used, used + size(xs), 0);
		for (int i = 0; i < size(xs); i++) {
			if (cnt == 0 || (i == d.first || i == d.second)) {
				dfs(i);
				break;
			}
		}
		
	//	cout << "ord: ";
		//for (int x : ord) cout << x << ' '; cout << endl;
		if (cnt == 2) {
			for (int i = 0; i + 1 < size(ord); i++) {
				if ((ord[i] == d.first && ord[i + 1] == d.second) || (ord[i] == d.second && ord[i + 1] == d.first)) {
					vector<int> trueOrd;
					for (int j = i; j >= 0; j--) {
						trueOrd.push_back(ord[j]);
					}
					for (int j = size(ord) - 1; j > i; j--) {
						trueOrd.push_back(ord[j]);
					}
					ord = trueOrd;
					break;
				}
			}
		}

	//	for (int x : ord) cout << x << ' '; cout << endl;
		auto tmp = vs;
		for (int try_ : {0, 1}) {
			vector<int> ordV;
			for (int i = 0; i + 1 < size(ord); i++) {
				if (size(vs[myHash(ord[i], ord[i + 1])]) == 0) {
					break;
				}
				ordV.push_back(vs[myHash(ord[i], ord[i + 1])].back());
				vs[myHash(ord[i], ord[i + 1])].pop_back();
			}
			if (size(ordV) + 1 == n) {
				vector<int> have(n, 1);
				for (int x : ordV) have[x] = 0;
				for (int i = 0; i < n; i++) if (have[i]) ordV.push_back(i);
			}
		
			if (size(ordV) != n) {
				reverse(all(ord));
				vs = tmp;
				continue;
			}

			bool fl = 1;
			for (int k = 0; k + 1 < size(ordV); k++) {
				if (a[ordV[k]].second != xs[a[ordV[k + 1]].first]) {
					fl = 0;
				}
			}
			if (fl) {
				cout << "Yes\n";
				for (int x : ordV) {
					cout << x + 1 << ' ';
				}
				exit(0);
			}
			reverse(all(ord));
			vs = tmp;
		}
	} 
}

unordered_map<int, int> cntStart;

vector<int> order;

unordered_map<int, int> was;

inline void quickCheck(int step) {
	if (was.find(step) != was.end()) return;
	was[step] = 1;
	int can = 0;

	unordered_map<int, int> cur;
	for (int i : order) {
		if (cntStart.find(step - a[i].second) == cntStart.end()) {
			if (!can) can = 1;
			else return;
		}
	}
	auto tmp = a;
	solve(step);
	a = tmp;
}

double startTime = clock();

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	if (n <= 8) FL = 1;
	order.resize(n);
	iota(all(order), 0);
	mt19937 gen(228);
	shuffle(all(order), gen);
	int step = -1;
	for (int i = 0; i < n; i++) {
		int m, s;
		cin >> m >> s;
		int first, last;
		for (int j = 0; j < m; j++) {
			int p;
			cin >> p;
			if (j == 0) first = p;
			if (j > 0) {
				if (step == -1) {
					step = p - last;
				}
				else if (p - last != step) {
					cout << "No\n";
					return 0;
				}
			}
			last = p;
		}
		a.emplace_back(first, s - last);
	}
	if (step != -1) {
		solve(step);
		cout << "No\n";
		return 0;
	}
	if (n == 1) {
		cout << "Yes\n1";
		return 0;
	}
	for (int i = 0; i < n; i++) {
		cntStart[a[i].first]++;
	}
	int x = gen() % n, y = gen() % n;
	while (x == y) {
		x = gen() % n;
	}
	int pt = 0;
	while (pt < size(order)) {
		if (order[pt] != x) {
			quickCheck(a[x].second + a[order[pt]].first);
		}
		if (order[pt] != y) {
			quickCheck(a[y].second + a[order[pt]].first);
		}
		pt++;
	}
	cout << "No\n";
	
}